#ifndef EFL_GENERATED_EVAS_3D_OBJECT_HH
#define EFL_GENERATED_EVAS_3D_OBJECT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_object.eo.h"
}

#include "eo_base.eo.hh"
#include "evas_common_interface.eo.hh"

struct evas_3d_object;

namespace eo_cxx {

struct evas_3d_object
{
   /// @brief Notify the object regarding its  state change.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change(Evas_3D_State state_, Evas_3D_Object * ref_) const;


   /// @brief Returns the type of the object.
   ///
   Evas_3D_Object_Type type_get() const;


   /// @brief Returns the type of the object.
   ///
   /// @param type 
   ///
   void type_set(Evas_3D_Object_Type type_) const;


   /// @brief Returns the status of a particular state of the object.
   ///
   /// @param state State whose status is being asked
   ///
   bool dirty_get(Evas_3D_State state_) const;


   /// @brief Update request for the object.
   ///
   void update() const;


   /// @brief Pure virtual update_notify function..
   /// Update request for the object.
   ///
   void update_notify() const;


   /// @brief Pure virtual change_notify function..
   /// Update request for the object.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_OBJECT_CLASS);
   }

   operator ::evas_3d_object() const;
   operator ::evas_3d_object&();
   operator ::evas_3d_object const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas_3d_object*() const { return static_cast<::evas_3d_object*>(static_cast<D const*>(this)->p); }
      operator ::evas_3d_object const*() const { return static_cast<::evas_3d_object const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas_3d_object const*() const { return static_cast<::evas_3d_object const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

struct evas_3d_object
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
{
   evas_3d_object(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : evas_3d_object(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_object(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_object(evas_3d_object const& other)
      : evas_3d_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_object() {}

   /// @brief Notify the object regarding its  state change.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change(Evas_3D_State state_, Evas_3D_Object * ref_) const;


   /// @brief Returns the type of the object.
   ///
   Evas_3D_Object_Type type_get() const;


   /// @brief Returns the type of the object.
   ///
   /// @param type 
   ///
   void type_set(Evas_3D_Object_Type type_) const;


   /// @brief Returns the status of a particular state of the object.
   ///
   /// @param state State whose status is being asked
   ///
   bool dirty_get(Evas_3D_State state_) const;


   /// @brief Update request for the object.
   ///
   void update() const;


   /// @brief Pure virtual update_notify function..
   /// Update request for the object.
   ///
   void update_notify() const;


   /// @brief Pure virtual change_notify function..
   /// Update request for the object.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_OBJECT_CLASS);
   }

   struct address_of
      : ::eo_cxx::evas_3d_object::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas_3d_object* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas_3d_object::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas_3d_object const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_3D_OBJECT_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas_3d_object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas_3d_object>::value, "");

inline void evas_3d_object::change(Evas_3D_State state_, Evas_3D_Object * ref_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_change(state_, ref_));
}


inline Evas_3D_Object_Type evas_3d_object::type_get() const
{
   Evas_3D_Object_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_object_type_get());
   return _tmp_ret;
}


inline void evas_3d_object::type_set(Evas_3D_Object_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_type_set(type_));
}


inline bool evas_3d_object::dirty_get(Evas_3D_State state_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_object_dirty_get(state_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void evas_3d_object::update() const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_update());
}


inline void evas_3d_object::update_notify() const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_update_notify());
}


inline void evas_3d_object::change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
}


inline void eo_cxx::evas_3d_object::change(Evas_3D_State state_, Evas_3D_Object * ref_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_change(state_, ref_));
}


inline Evas_3D_Object_Type eo_cxx::evas_3d_object::type_get() const
{
   Evas_3D_Object_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_object_type_get());
   return _tmp_ret;
}


inline void eo_cxx::evas_3d_object::type_set(Evas_3D_Object_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_type_set(type_));
}


inline bool eo_cxx::evas_3d_object::dirty_get(Evas_3D_State state_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_object_dirty_get(state_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::evas_3d_object::update() const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_update());
}


inline void eo_cxx::evas_3d_object::update_notify() const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_update_notify());
}


inline void eo_cxx::evas_3d_object::change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
}


inline ::eo_cxx::evas_3d_object::operator ::evas_3d_object() const
{
   return *static_cast<::evas_3d_object const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_object::operator ::evas_3d_object&()
{
   return *static_cast<::evas_3d_object*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_object::operator ::evas_3d_object const&() const
{
   return *static_cast<::evas_3d_object const*>(static_cast<void const*>(this));
}

template <typename T>
void _evas_3d_object_change_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   try
      {
         static_cast<T*>(self->this_)->change(state_, ref_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Object_Type _evas_3d_object_type_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Object_Type _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->type_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_object_type_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Object_Type type_)
{
   try
      {
         static_cast<T*>(self->this_)->type_set(type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_object_dirty_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->dirty_get(state_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_object_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->update();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_object_update_notify_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->update_notify();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_object_change_notify_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   try
      {
         static_cast<T*>(self->this_)->change_notify(state_, ref_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_object >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
   {
      virtual void change(Evas_3D_State state_, Evas_3D_Object * ref_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change(state_, ref_));
      }

      virtual Evas_3D_Object_Type type_get()
      {
         Evas_3D_Object_Type _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_object_type_get());
            return _tmp_ret;
      }

      virtual void type_set(Evas_3D_Object_Type type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_type_set(type_));
      }

      virtual bool dirty_get(Evas_3D_State state_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_object_dirty_get(state_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void update()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update());
      }

      virtual void update_notify()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update_notify());
      }

      virtual void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change_notify(state_, ref_));
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_object >
{
   static const int value = 7 + operation_description_class_size<::eo::base >::value + operation_description_class_size<::evas::common_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_object>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_object_change_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_object_type_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_object_type_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_object_type_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_object_type_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_object_dirty_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_object_dirty_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_object_update_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_object_update_notify_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update_notify);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_object_change_notify_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change_notify);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[7]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[7 + operation_description_class_size<::eo::base>::value]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas_3d_object >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas_3d_object, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas_3d_object>)
{
   return (EVAS_3D_OBJECT_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_OBJECT_HH

